#!/usr/bin/env python3
# -*- coding: utf-8 -*-
"""
Created on Mon Aug  7 21:09:43 2017

@author: andres
"""

# Ejemplo de regresion lineal

import tensorflow as tf
import numpy as np
import matplotlib.pyplot as plt

# Parametros

learning_rate = 0.001
training_iters = 100

# Datos 
train_X = np.asarray([3.3,4.4,5.5,6.71,6.93,4.168,9.779,6.182,7.59,2.167,
                         7.042,10.791,5.313,7.997,5.654,9.27,3.1])
train_Y = np.asarray([1.7,2.76,2.09,3.19,1.694,1.573,3.366,2.596,2.53,1.221,
                         2.827,3.465,1.65,2.904,2.42,2.94,1.3])

data=np.hstack((train_X.reshape(-1,1),train_Y.reshape(-1,1)))
n_samples=data.shape[0]


# Creacion de los placeholders para cargar los datos y los predictores.
X = tf.placeholder(tf.float32, name='X')
Y = tf.placeholder(tf.float32, name='Y')

# Creacion de los pesos y del bias, inicializados a cero: Y=wX+b
w = tf.Variable(0.0, name='weights')
b = tf.Variable(0.0, name='bias')

# Modelo: Y=wX+b
Y_predicted = X * w + b 

# Definicion de la funcion de perdida: 
loss = tf.square(Y - Y_predicted, name='loss')

# Definicion del optimizador: gradiente descendente
optimizer = tf.train.GradientDescentOptimizer(learning_rate=learning_rate).minimize(loss)

# Definicion de la sesion -> operaciones a ejecutar dentro de la sesion
with tf.Session() as sess:
	# Inicializacion de las variables w, b
	sess.run(tf.global_variables_initializer()) 
		
	# Entrnamiento
	for i in range(train_iters): 
		total_loss = 0
		for x, y in data:
			# Ejecutar el optimizador en esta iteracion (sess.run)
			_, l = sess.run([optimizer, loss], feed_dict={X: x, Y:y}) 
			total_loss += l
		print ('Iteracion %d, Mean loss=%1.2f'%(i, total_loss/n_samples))
	
	#Muestra los valores finales de w, b
	w_value, b_value = sess.run([w, b])
    
#Grafico
X, Y = data.T[0], data.T[1]
plt.plot(X, Y, 'bo', label='Datos reales')
plt.xlabel('Predictor (X)')
plt.ylabel('Respuesta (Y)')
plt.savefig('muestras_regresion.png')
plt.plot(X, X * w_value + b_value, 'r', label='Prediccion')
plt.legend()
plt.show()